// Code generated by ent, DO NOT EDIT.

package ent

import (
	"context"
	"errors"
	"fmt"
	"gochassis/ent/chat"
	"gochassis/ent/chatroom"
	"gochassis/ent/profile"
	"time"

	"entgo.io/ent/dialect/sql/sqlgraph"
	"entgo.io/ent/schema/field"
)

// ChatCreate is the builder for creating a Chat entity.
type ChatCreate struct {
	config
	mutation *ChatMutation
	hooks    []Hook
}

// SetText sets the "text" field.
func (cc *ChatCreate) SetText(s string) *ChatCreate {
	cc.mutation.SetText(s)
	return cc
}

// SetAttachment sets the "attachment" field.
func (cc *ChatCreate) SetAttachment(s string) *ChatCreate {
	cc.mutation.SetAttachment(s)
	return cc
}

// SetNillableAttachment sets the "attachment" field if the given value is not nil.
func (cc *ChatCreate) SetNillableAttachment(s *string) *ChatCreate {
	if s != nil {
		cc.SetAttachment(*s)
	}
	return cc
}

// SetAttachmentType sets the "attachment_type" field.
func (cc *ChatCreate) SetAttachmentType(s string) *ChatCreate {
	cc.mutation.SetAttachmentType(s)
	return cc
}

// SetNillableAttachmentType sets the "attachment_type" field if the given value is not nil.
func (cc *ChatCreate) SetNillableAttachmentType(s *string) *ChatCreate {
	if s != nil {
		cc.SetAttachmentType(*s)
	}
	return cc
}

// SetFrontendUUID sets the "frontend_uuid" field.
func (cc *ChatCreate) SetFrontendUUID(s string) *ChatCreate {
	cc.mutation.SetFrontendUUID(s)
	return cc
}

// SetCreatedAt sets the "created_at" field.
func (cc *ChatCreate) SetCreatedAt(t time.Time) *ChatCreate {
	cc.mutation.SetCreatedAt(t)
	return cc
}

// SetNillableCreatedAt sets the "created_at" field if the given value is not nil.
func (cc *ChatCreate) SetNillableCreatedAt(t *time.Time) *ChatCreate {
	if t != nil {
		cc.SetCreatedAt(*t)
	}
	return cc
}

// SetUpdatedAt sets the "updated_at" field.
func (cc *ChatCreate) SetUpdatedAt(t time.Time) *ChatCreate {
	cc.mutation.SetUpdatedAt(t)
	return cc
}

// SetNillableUpdatedAt sets the "updated_at" field if the given value is not nil.
func (cc *ChatCreate) SetNillableUpdatedAt(t *time.Time) *ChatCreate {
	if t != nil {
		cc.SetUpdatedAt(*t)
	}
	return cc
}

// SetDeletedAt sets the "deleted_at" field.
func (cc *ChatCreate) SetDeletedAt(t time.Time) *ChatCreate {
	cc.mutation.SetDeletedAt(t)
	return cc
}

// SetNillableDeletedAt sets the "deleted_at" field if the given value is not nil.
func (cc *ChatCreate) SetNillableDeletedAt(t *time.Time) *ChatCreate {
	if t != nil {
		cc.SetDeletedAt(*t)
	}
	return cc
}

// SetReplyTo sets the "reply_to" field.
func (cc *ChatCreate) SetReplyTo(i int) *ChatCreate {
	cc.mutation.SetReplyTo(i)
	return cc
}

// SetNillableReplyTo sets the "reply_to" field if the given value is not nil.
func (cc *ChatCreate) SetNillableReplyTo(i *int) *ChatCreate {
	if i != nil {
		cc.SetReplyTo(*i)
	}
	return cc
}

// SetProfileID sets the "profile" edge to the Profile entity by ID.
func (cc *ChatCreate) SetProfileID(id int) *ChatCreate {
	cc.mutation.SetProfileID(id)
	return cc
}

// SetProfile sets the "profile" edge to the Profile entity.
func (cc *ChatCreate) SetProfile(p *Profile) *ChatCreate {
	return cc.SetProfileID(p.ID)
}

// SetChatRoomID sets the "chat_room" edge to the ChatRoom entity by ID.
func (cc *ChatCreate) SetChatRoomID(id int) *ChatCreate {
	cc.mutation.SetChatRoomID(id)
	return cc
}

// SetChatRoom sets the "chat_room" edge to the ChatRoom entity.
func (cc *ChatCreate) SetChatRoom(c *ChatRoom) *ChatCreate {
	return cc.SetChatRoomID(c.ID)
}

// SetReplyToEdgeID sets the "reply_to_edge" edge to the Chat entity by ID.
func (cc *ChatCreate) SetReplyToEdgeID(id int) *ChatCreate {
	cc.mutation.SetReplyToEdgeID(id)
	return cc
}

// SetNillableReplyToEdgeID sets the "reply_to_edge" edge to the Chat entity by ID if the given value is not nil.
func (cc *ChatCreate) SetNillableReplyToEdgeID(id *int) *ChatCreate {
	if id != nil {
		cc = cc.SetReplyToEdgeID(*id)
	}
	return cc
}

// SetReplyToEdge sets the "reply_to_edge" edge to the Chat entity.
func (cc *ChatCreate) SetReplyToEdge(c *Chat) *ChatCreate {
	return cc.SetReplyToEdgeID(c.ID)
}

// AddReplyIDs adds the "replies" edge to the Chat entity by IDs.
func (cc *ChatCreate) AddReplyIDs(ids ...int) *ChatCreate {
	cc.mutation.AddReplyIDs(ids...)
	return cc
}

// AddReplies adds the "replies" edges to the Chat entity.
func (cc *ChatCreate) AddReplies(c ...*Chat) *ChatCreate {
	ids := make([]int, len(c))
	for i := range c {
		ids[i] = c[i].ID
	}
	return cc.AddReplyIDs(ids...)
}

// Mutation returns the ChatMutation object of the builder.
func (cc *ChatCreate) Mutation() *ChatMutation {
	return cc.mutation
}

// Save creates the Chat in the database.
func (cc *ChatCreate) Save(ctx context.Context) (*Chat, error) {
	cc.defaults()
	return withHooks[*Chat, ChatMutation](ctx, cc.sqlSave, cc.mutation, cc.hooks)
}

// SaveX calls Save and panics if Save returns an error.
func (cc *ChatCreate) SaveX(ctx context.Context) *Chat {
	v, err := cc.Save(ctx)
	if err != nil {
		panic(err)
	}
	return v
}

// Exec executes the query.
func (cc *ChatCreate) Exec(ctx context.Context) error {
	_, err := cc.Save(ctx)
	return err
}

// ExecX is like Exec, but panics if an error occurs.
func (cc *ChatCreate) ExecX(ctx context.Context) {
	if err := cc.Exec(ctx); err != nil {
		panic(err)
	}
}

// defaults sets the default values of the builder before save.
func (cc *ChatCreate) defaults() {
	if _, ok := cc.mutation.CreatedAt(); !ok {
		v := chat.DefaultCreatedAt()
		cc.mutation.SetCreatedAt(v)
	}
	if _, ok := cc.mutation.UpdatedAt(); !ok {
		v := chat.DefaultUpdatedAt()
		cc.mutation.SetUpdatedAt(v)
	}
}

// check runs all checks and user-defined validators on the builder.
func (cc *ChatCreate) check() error {
	if _, ok := cc.mutation.Text(); !ok {
		return &ValidationError{Name: "text", err: errors.New(`ent: missing required field "Chat.text"`)}
	}
	if v, ok := cc.mutation.Text(); ok {
		if err := chat.TextValidator(v); err != nil {
			return &ValidationError{Name: "text", err: fmt.Errorf(`ent: validator failed for field "Chat.text": %w`, err)}
		}
	}
	if _, ok := cc.mutation.FrontendUUID(); !ok {
		return &ValidationError{Name: "frontend_uuid", err: errors.New(`ent: missing required field "Chat.frontend_uuid"`)}
	}
	if _, ok := cc.mutation.CreatedAt(); !ok {
		return &ValidationError{Name: "created_at", err: errors.New(`ent: missing required field "Chat.created_at"`)}
	}
	if _, ok := cc.mutation.UpdatedAt(); !ok {
		return &ValidationError{Name: "updated_at", err: errors.New(`ent: missing required field "Chat.updated_at"`)}
	}
	if _, ok := cc.mutation.ProfileID(); !ok {
		return &ValidationError{Name: "profile", err: errors.New(`ent: missing required edge "Chat.profile"`)}
	}
	if _, ok := cc.mutation.ChatRoomID(); !ok {
		return &ValidationError{Name: "chat_room", err: errors.New(`ent: missing required edge "Chat.chat_room"`)}
	}
	return nil
}

func (cc *ChatCreate) sqlSave(ctx context.Context) (*Chat, error) {
	if err := cc.check(); err != nil {
		return nil, err
	}
	_node, _spec := cc.createSpec()
	if err := sqlgraph.CreateNode(ctx, cc.driver, _spec); err != nil {
		if sqlgraph.IsConstraintError(err) {
			err = &ConstraintError{msg: err.Error(), wrap: err}
		}
		return nil, err
	}
	id := _spec.ID.Value.(int64)
	_node.ID = int(id)
	cc.mutation.id = &_node.ID
	cc.mutation.done = true
	return _node, nil
}

func (cc *ChatCreate) createSpec() (*Chat, *sqlgraph.CreateSpec) {
	var (
		_node = &Chat{config: cc.config}
		_spec = sqlgraph.NewCreateSpec(chat.Table, sqlgraph.NewFieldSpec(chat.FieldID, field.TypeInt))
	)
	if value, ok := cc.mutation.Text(); ok {
		_spec.SetField(chat.FieldText, field.TypeString, value)
		_node.Text = value
	}
	if value, ok := cc.mutation.Attachment(); ok {
		_spec.SetField(chat.FieldAttachment, field.TypeString, value)
		_node.Attachment = value
	}
	if value, ok := cc.mutation.AttachmentType(); ok {
		_spec.SetField(chat.FieldAttachmentType, field.TypeString, value)
		_node.AttachmentType = value
	}
	if value, ok := cc.mutation.FrontendUUID(); ok {
		_spec.SetField(chat.FieldFrontendUUID, field.TypeString, value)
		_node.FrontendUUID = value
	}
	if value, ok := cc.mutation.CreatedAt(); ok {
		_spec.SetField(chat.FieldCreatedAt, field.TypeTime, value)
		_node.CreatedAt = value
	}
	if value, ok := cc.mutation.UpdatedAt(); ok {
		_spec.SetField(chat.FieldUpdatedAt, field.TypeTime, value)
		_node.UpdatedAt = value
	}
	if value, ok := cc.mutation.DeletedAt(); ok {
		_spec.SetField(chat.FieldDeletedAt, field.TypeTime, value)
		_node.DeletedAt = value
	}
	if nodes := cc.mutation.ProfileIDs(); len(nodes) > 0 {
		edge := &sqlgraph.EdgeSpec{
			Rel:     sqlgraph.M2O,
			Inverse: true,
			Table:   chat.ProfileTable,
			Columns: []string{chat.ProfileColumn},
			Bidi:    false,
			Target: &sqlgraph.EdgeTarget{
				IDSpec: sqlgraph.NewFieldSpec(profile.FieldID, field.TypeInt),
			},
		}
		for _, k := range nodes {
			edge.Target.Nodes = append(edge.Target.Nodes, k)
		}
		_node.profile_chats = &nodes[0]
		_spec.Edges = append(_spec.Edges, edge)
	}
	if nodes := cc.mutation.ChatRoomIDs(); len(nodes) > 0 {
		edge := &sqlgraph.EdgeSpec{
			Rel:     sqlgraph.M2O,
			Inverse: true,
			Table:   chat.ChatRoomTable,
			Columns: []string{chat.ChatRoomColumn},
			Bidi:    false,
			Target: &sqlgraph.EdgeTarget{
				IDSpec: sqlgraph.NewFieldSpec(chatroom.FieldID, field.TypeInt),
			},
		}
		for _, k := range nodes {
			edge.Target.Nodes = append(edge.Target.Nodes, k)
		}
		_node.chat_room_chats = &nodes[0]
		_spec.Edges = append(_spec.Edges, edge)
	}
	if nodes := cc.mutation.ReplyToEdgeIDs(); len(nodes) > 0 {
		edge := &sqlgraph.EdgeSpec{
			Rel:     sqlgraph.M2O,
			Inverse: true,
			Table:   chat.ReplyToEdgeTable,
			Columns: []string{chat.ReplyToEdgeColumn},
			Bidi:    false,
			Target: &sqlgraph.EdgeTarget{
				IDSpec: sqlgraph.NewFieldSpec(chat.FieldID, field.TypeInt),
			},
		}
		for _, k := range nodes {
			edge.Target.Nodes = append(edge.Target.Nodes, k)
		}
		_node.ReplyTo = nodes[0]
		_spec.Edges = append(_spec.Edges, edge)
	}
	if nodes := cc.mutation.RepliesIDs(); len(nodes) > 0 {
		edge := &sqlgraph.EdgeSpec{
			Rel:     sqlgraph.O2M,
			Inverse: false,
			Table:   chat.RepliesTable,
			Columns: []string{chat.RepliesColumn},
			Bidi:    false,
			Target: &sqlgraph.EdgeTarget{
				IDSpec: sqlgraph.NewFieldSpec(chat.FieldID, field.TypeInt),
			},
		}
		for _, k := range nodes {
			edge.Target.Nodes = append(edge.Target.Nodes, k)
		}
		_spec.Edges = append(_spec.Edges, edge)
	}
	return _node, _spec
}

// ChatCreateBulk is the builder for creating many Chat entities in bulk.
type ChatCreateBulk struct {
	config
	builders []*ChatCreate
}

// Save creates the Chat entities in the database.
func (ccb *ChatCreateBulk) Save(ctx context.Context) ([]*Chat, error) {
	specs := make([]*sqlgraph.CreateSpec, len(ccb.builders))
	nodes := make([]*Chat, len(ccb.builders))
	mutators := make([]Mutator, len(ccb.builders))
	for i := range ccb.builders {
		func(i int, root context.Context) {
			builder := ccb.builders[i]
			builder.defaults()
			var mut Mutator = MutateFunc(func(ctx context.Context, m Mutation) (Value, error) {
				mutation, ok := m.(*ChatMutation)
				if !ok {
					return nil, fmt.Errorf("unexpected mutation type %T", m)
				}
				if err := builder.check(); err != nil {
					return nil, err
				}
				builder.mutation = mutation
				var err error
				nodes[i], specs[i] = builder.createSpec()
				if i < len(mutators)-1 {
					_, err = mutators[i+1].Mutate(root, ccb.builders[i+1].mutation)
				} else {
					spec := &sqlgraph.BatchCreateSpec{Nodes: specs}
					// Invoke the actual operation on the latest mutation in the chain.
					if err = sqlgraph.BatchCreate(ctx, ccb.driver, spec); err != nil {
						if sqlgraph.IsConstraintError(err) {
							err = &ConstraintError{msg: err.Error(), wrap: err}
						}
					}
				}
				if err != nil {
					return nil, err
				}
				mutation.id = &nodes[i].ID
				if specs[i].ID.Value != nil {
					id := specs[i].ID.Value.(int64)
					nodes[i].ID = int(id)
				}
				mutation.done = true
				return nodes[i], nil
			})
			for i := len(builder.hooks) - 1; i >= 0; i-- {
				mut = builder.hooks[i](mut)
			}
			mutators[i] = mut
		}(i, ctx)
	}
	if len(mutators) > 0 {
		if _, err := mutators[0].Mutate(ctx, ccb.builders[0].mutation); err != nil {
			return nil, err
		}
	}
	return nodes, nil
}

// SaveX is like Save, but panics if an error occurs.
func (ccb *ChatCreateBulk) SaveX(ctx context.Context) []*Chat {
	v, err := ccb.Save(ctx)
	if err != nil {
		panic(err)
	}
	return v
}

// Exec executes the query.
func (ccb *ChatCreateBulk) Exec(ctx context.Context) error {
	_, err := ccb.Save(ctx)
	return err
}

// ExecX is like Exec, but panics if an error occurs.
func (ccb *ChatCreateBulk) ExecX(ctx context.Context) {
	if err := ccb.Exec(ctx); err != nil {
		panic(err)
	}
}
